package de.ubt.ai1.modgraph.example.eRefactoring.connector;

import java.io.IOException;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JOptionPane;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.change.ChangeDescription;
import org.eclipse.emf.ecore.change.util.ChangeRecorder;
import org.eclipse.emf.ecore.presentation.EcoreEditor;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreEList;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.handlers.HandlerUtil;

public class ExtractSuperClassConnector extends RefactoringConnector {
	private IEditorPart activeEditor;

	@SuppressWarnings("unchecked")
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {

		activeEditor = HandlerUtil.getActiveEditor(event);
		window = HandlerUtil.getActiveWorkbenchWindow(event);

		if (activeEditor instanceof EcoreEditor) {
			EcoreEditor ecoreEditor = (EcoreEditor) activeEditor;
			ecoreEditor.doSave(null);
			TreeSelection sel = (TreeSelection) ecoreEditor.getSelection();
			Object obj = sel.getFirstElement();

			if (obj instanceof EClass) {
				EClass sourceClass = (EClass) obj;
				EPackage pack = sourceClass.getEPackage();
				Resource res = pack.eResource();
				List<String> classNames = new LinkedList<String>();
				List<EClassifier> classes = pack.getEClassifiers();
				for (EClassifier c : classes) {
					if (c instanceof EClass)
						classNames.add(c.getName());
				}
				initRefactoring(pack.eContents());
				String newName = JOptionPane
						.showInputDialog("Enter the name for the extracted superclass.");
				if (classNames.contains(newName)) {
					JOptionPane.showMessageDialog(null,
							"A class with that name already exists.", "ERROR!",
							JOptionPane.ERROR_MESSAGE);
					return null;
				}
				if (newName.equals("")) {
					JOptionPane.showMessageDialog(null,
							"Selected name is not valid.", "ERROR!",
							JOptionPane.ERROR_MESSAGE);
					return null;
				}
//				int cond = JOptionPane.YES_OPTION;
//				JOptionPane.showMessageDialog(null, "Chosse additional class",
//						"", JOptionPane.INFORMATION_MESSAGE);
//				EList<String> classesForRule = new BasicEList<String>();
//				List<String> classesNames = new LinkedList<String>();
//				try {
//					for (EClass a : helper.getAllClasses())
//						classesNames.add(a.getName());
//				} catch (Throwable e1) {
//					JOptionPane.showMessageDialog(null, "Refactoring failed.",
//							"ERROR!", JOptionPane.ERROR_MESSAGE);
//					e1.printStackTrace();
//				}
//				classesNames.remove(sourceClass.getName());
//				while (cond == JOptionPane.YES_OPTION
//						&& !classesNames.isEmpty()) {
//					String temp = getSelectedFromDialog(classesNames,
//							"Choose a class.");
//					classesForRule.add(temp);
//					classesNames.remove(temp);
//					if (!classesNames.isEmpty())
//						cond = JOptionPane.showConfirmDialog(null,
//								"Add another class?", "",
//								JOptionPane.YES_NO_OPTION);
//				}
//				classesForRule.add(sourceClass.getName());

//				ChangeRecorder recorder = new ChangeRecorder(sourceClass);
				try {
				//	refactoring.extractSuperClass(classesForRule, newName); ANDERS!!
					Iterator<EObject> iter = sel.iterator();
					List l = sel.toList();
					EList<EClass> classesForRule = new BasicEList<EClass>();
							
					while(iter.hasNext()){
						EObject obj2 =  iter.next();
						if(obj instanceof EClass)
							classesForRule.add((EClass) obj2);
					}
					
					refactoring.extractSuperClass2((EList<EClass>) classesForRule, newName);

				} catch (Throwable e) {
					JOptionPane.showMessageDialog(null, "Refactoring failed.",
							"ERROR!", JOptionPane.ERROR_MESSAGE);
					e.printStackTrace();
					return null;
				}
				try {
					res.save(Collections.EMPTY_MAP);
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (sourceClass.getESuperTypes().get(0).getEOperations() != null)
					JOptionPane.showMessageDialog(null,"Please update parameters of extracted methods.","WARNING!", JOptionPane.WARNING_MESSAGE);
//				try {
//					ChangeDescription description = recorder.endRecording();
//					if (!(description.eContents().isEmpty())) {
//						propagateChanges(description, sourceClass);
//					}					
//				} catch (Throwable e){
//					e.printStackTrace();
//				}
			}

		}
		return null;

	}

	@Override
	protected void applyToAffectedObjects(ENamedElement eNamedElement) {
		for (Resource res : gtResources) {
			
			URI resURI = res.getURI();
			String fragment = resURI.toString();
			String[] resRuleNameArray = fragment.split("/");
			String resRuleName = resRuleNameArray[resRuleNameArray.length-1];			
			int response = JOptionPane.showConfirmDialog(null,
					"Would you like to validate the GT rule " + resRuleName + "?", "Attention",
					JOptionPane.YES_NO_OPTION);
			if(response == 0){
				try{
					boolean result = callValidation(res);
					if(result == false){
						JOptionPane.showMessageDialog(null,
								"Errors exist in the rule " + resRuleName + "\nPlease check it manually.", "Validation failed!",
								JOptionPane.ERROR_MESSAGE);
					}
				} catch (Throwable e){
					e.printStackTrace();
				}
			}
		}
	}	
}