package de.ubt.ai1.modgraph.example.eRefactoring.connector;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.channels.FileChannel;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JOptionPane;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.change.ChangeDescription;
import org.eclipse.emf.ecore.change.FeatureChange;
import org.eclipse.emf.ecore.change.util.ChangeRecorder;
import org.eclipse.emf.ecore.presentation.EcoreEditor;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.BasicCompartment;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.Shape;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.ui.handlers.HandlerUtil;

import de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringFactory;
import de.ubt.ai1.modgraph.gt.gtEngine.GPBoundNode;
import de.ubt.ai1.modgraph.gt.gtEngine.GPElement;
import de.ubt.ai1.modgraph.gt.gtEngine.GPObject;
import de.ubt.ai1.modgraph.gt.gtEngine.GPUnboundNode;
import de.ubt.ai1.modgraph.gt.gtEngine.GTAttribute;
import de.ubt.ai1.modgraph.gt.gtEngine.GTField;
import de.ubt.ai1.modgraph.gt.gtEngine.GTGraphPattern;
import de.ubt.ai1.modgraph.gt.gtEngine.GTNegativeApplicationCondition;
import de.ubt.ai1.modgraph.gt.gtEngine.GTNode;
import de.ubt.ai1.modgraph.gt.gtEngine.GTPath;
import de.ubt.ai1.modgraph.gt.gtEngine.GTPostcondition;
import de.ubt.ai1.modgraph.gt.gtEngine.GTPrecondition;
import de.ubt.ai1.modgraph.gt.gtEngine.GTThisObject;
import de.ubt.ai1.modgraph.gt.gtEngine.GraphTransformationRule;
import de.ubt.ai1.modgraph.gt.gtEngine.NACBoundNode;
import de.ubt.ai1.modgraph.gt.gtEngine.NACElement;
import de.ubt.ai1.modgraph.gt.gtEngine.NACObject;
import de.ubt.ai1.modgraph.gt.gtEngine.NACParameter;


public class MoveEAttributeConnector extends RefactoringConnector {

	private String attrName = "";
	private String sourceClassName = "";
	private String targetClassName = "";
	private EClass sourceClass;
	private EClass targetClass;
	private	int i = 0;

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {

		activeEditor = HandlerUtil.getActiveEditor(event);
		window = HandlerUtil.getActiveWorkbenchWindow(event);

		if (activeEditor instanceof EcoreEditor) {
			EcoreEditor ecoreEditor = (EcoreEditor) activeEditor;
			ecoreEditor.doSave(null);

			TreeSelection sel = (TreeSelection) ecoreEditor.getSelection();
			Object obj = sel.getFirstElement();

			if (obj instanceof EAttribute) {
				EAttribute attr = (EAttribute) obj;
				ChangeRecorder recorder = new ChangeRecorder(attr);
				sourceClass = (EClass) attr.eContainer();
				EPackage pack = sourceClass.getEPackage();
				List<String> classNames = new LinkedList<String>();
				List<EClassifier> classes = pack.getEClassifiers();
				for (EClassifier c : classes) {
					if (c instanceof EClass)
						classNames.add(c.getName());
				}
				initRefactoring(sourceClass.getEPackage().eContents());
				
				targetClassName = getSelectedFromDialog(classNames, "Choose target class.");
				
				targetClass = helper.getClass(targetClassName);				
				
				attrName = attr.getName();
				sourceClassName = sourceClass.getName();
				
				try {
					refactoring.moveEAttribute(attrName, targetClassName, sourceClassName);
				} catch (Throwable e) {
					JOptionPane.showMessageDialog(
									null,
									"The target class already contains an attribute with the same name.",
									"ERROR", JOptionPane.ERROR_MESSAGE);
					e.printStackTrace();
					return null;
				}
				
				try {
					sourceClass.getEPackage().eResource().save(Collections.EMPTY_MAP);
				} catch (IOException e) {
					e.printStackTrace();
				}

				
				ChangeDescription description = recorder.endRecording();
				if (!(description.eContents().isEmpty())) {
					propagateChanges(description, attr, sourceClass.eResource());
				}		
						
//				// For runtime testing only
//				File source = new File("C:\\Users\\Duemmel\\Desktop\\Projekt\\TimeTestModels\\BTMoveAttribute\\BugModel.ecore");
//				File dest = new File("C:\\Users\\Duemmel\\runtime-EclipseApplication2\\Bugtracker\\model\\BugModel.ecore");
//				FileChannel inputChannel = null;
//				FileChannel outputChannel = null;
//				try {
//					inputChannel = new FileInputStream(source).getChannel();
//					outputChannel = new FileOutputStream(dest).getChannel();
//					outputChannel.transferFrom(inputChannel, 0, inputChannel.size());
//				} catch (Throwable e) {	e.printStackTrace();} 
//				finally {
//					try {
//						inputChannel.close();
//						outputChannel.close();
//					} catch (IOException e) {
//						e.printStackTrace();
//					}
//				}
//				source = new File("C:\\Users\\Duemmel\\Desktop\\Projekt\\TimeTestModels\\BTMoveAttribute\\gt\\Project_createTicket.gtEngine");
//				dest = new File("C:\\Users\\Duemmel\\runtime-EclipseApplication2\\Bugtracker\\model\\gt\\Project_createTicket.gtEngine");
//				inputChannel = null;
//				outputChannel = null;
//				try {
//					inputChannel = new FileInputStream(source).getChannel();
//					outputChannel = new FileOutputStream(dest).getChannel();
//					outputChannel.transferFrom(inputChannel, 0, inputChannel.size());
//				} catch (Throwable e) {	e.printStackTrace();} 
//				finally {
//					try {
//						inputChannel.close();
//						outputChannel.close();
//					} catch (IOException e) {e.printStackTrace();}
//				}
//				execute2();
//				i = 0;
				
			}

		}
		return null;

	}	
	
	/**
	 * If the targetClass is in the rule moves the attribute to it, else deletes
	 * the attribute from its containing class.
	 */
	@SuppressWarnings({ "rawtypes" })
	@Override
	protected void applyToAffectedObjects(ENamedElement eNamedElement) {
		for (Resource res : gtResources) {
			TreeIterator<EObject> iter = res.getAllContents();
			EList<EObject> objectsToRemove = new BasicEList<EObject>();
			String ruleName = "";
			while (iter.hasNext()) {
				EObject eObject = iter.next();
				if (eObject instanceof GraphTransformationRule<?, ?>) {
					ruleName = ((GraphTransformationRule) eObject).getName();
					try {
						propagation.propagateMoveAttributeInit((EAttribute) eNamedElement, sourceClass, targetClass, (GraphTransformationRule) eObject);
					} catch (Throwable e1) {
						e1.printStackTrace();
						break;
					}
				} 
				else if (eObject instanceof GTField	&& ((GTField) eObject).getKind().getName().equals("OCL_CONSTRAINT")) {
					String containerName = "OCL_CONSTRAINT";
					String expression = ((GTField) eObject).getContent();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTField) eObject).setContent(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if (eObject instanceof GTPath) {
					String containerName = "GTPath";
					String expression = ((GTPath) eObject).getExpression();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTPath) eObject).setExpression(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if(eObject instanceof GTPrecondition){
					String containerName = "GTPrecondition";
					String expression = ((GTPrecondition) eObject).getCondition();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTPrecondition) eObject).setCondition(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if(eObject instanceof GTPostcondition){
					String containerName = "GTPostcondition";
					String expression = ((GTPostcondition) eObject).getCondition();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTPostcondition) eObject).setCondition(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if(eObject instanceof Shape && objectsToRemove.contains(((Shape)eObject).getElement()))
					objectsToRemove.add(eObject);
			}
			propagation.cleanUpAndSave(objectsToRemove, res);
			
			URI resURI = res.getURI();
			String fragment = resURI.toString();
			String[] resRuleNameArray = fragment.split("/");
			String resRuleName = resRuleNameArray[resRuleNameArray.length-1];			
			int response = JOptionPane.showConfirmDialog(null,
					"Would you like to validate the GT rule " + resRuleName + "?", "Attention",
					JOptionPane.YES_NO_OPTION);
			if(response == 0){
				try{
					boolean result = callValidation(res);
					if(result == false){
						JOptionPane.showMessageDialog(null,
								"Errors exist in the rule " + resRuleName + "\nPlease check it manually.", "Validation failed!",
								JOptionPane.ERROR_MESSAGE);
					}
				} catch (Throwable e){
					e.printStackTrace();
				}
			}
		}
	}
	
	
	
//	// for runtime tests	
//	public Object execute2() throws ExecutionException { 
//		EcoreUtil.resolveAll(sourceClass.eResource());		
//		EAttribute attr = helper.getAttributeByName(targetClass, attrName);
//		sourceClass.getEStructuralFeatures().add(0, attr);
//		helper.removeAttributeByName(targetClass, attrName);
//		try {sourceClass.getEPackage().eResource().save(Collections.EMPTY_MAP);} catch (IOException e) {e.printStackTrace();}
//		ChangeRecorder recorder = new ChangeRecorder(attr);	
//		refactoring = ERefactoringFactory.eINSTANCE.createRefactoring();
//		helper = ERefactoringFactory.eINSTANCE.createHelper();
//		propagation = ERefactoringFactory.eINSTANCE.createPropagation();
//		initRefactoring(sourceClass.getEPackage().eContents());		
//		targetClassName = "Ticket";		
//		targetClass = helper.getClass(targetClassName);		
//		attrName = attr.getName();
//		sourceClassName = sourceClass.getName();	
//		
//		long preRefactoringNano = System.nanoTime();
//		
//		try {
//			refactoring.moveEAttribute(attrName, targetClassName, sourceClassName);
//		} catch (Throwable e) {
//			JOptionPane.showMessageDialog(
//							null,
//							"The target class already contains an attribute with the same name.",
//							"ERROR", JOptionPane.ERROR_MESSAGE);
//			e.printStackTrace();
//			return null;
//		}
//		
////		targetClass.getEStructuralFeatures().add(attr);
//
//		try {
//			sourceClass.getEPackage().eResource().save(Collections.EMPTY_MAP);
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//
//		long prePropagationNano = System.nanoTime();
//		
//		ChangeDescription description = recorder.endRecording();
//		if (!(description.eContents().isEmpty())) {
//			propagateChanges(description, attr);
//		}				
//
////		if (!(description.eContents().isEmpty())) {
////			propagateChanges2(description, attr);
////		}		
//		
//		long finalNano = System.nanoTime();
//						
//		try(PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:/Move_EAttribute_Refactoring.txt", true)))) {
//			out.println((prePropagationNano - preRefactoringNano));
//		}catch (IOException e) {}			
//		try(PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:/Move_EAttribute_Propagation.txt", true)))) {
//			out.println((finalNano - prePropagationNano));
//		}catch (IOException e) {}
//		
//		// For runtime testing only
//		File source = new File("C:\\Users\\Duemmel\\Desktop\\Projekt\\TimeTestModels\\BTMoveAttribute\\BugModel.ecore");
//		File dest = new File("C:\\Users\\Duemmel\\runtime-EclipseApplication2\\Bugtracker\\model\\BugModel.ecore");
//		FileChannel inputChannel = null;
//		FileChannel outputChannel = null;
//		try {
//			inputChannel = new FileInputStream(source).getChannel();
//			outputChannel = new FileOutputStream(dest).getChannel();
//			outputChannel.transferFrom(inputChannel, 0, inputChannel.size());
//		} catch (Throwable e) {	e.printStackTrace();} 
//		finally {
//			try {
//				inputChannel.close();
//				outputChannel.close();
//			} catch (IOException e) {
//				e.printStackTrace();
//			}
//		}
//		source = new File("C:\\Users\\Duemmel\\Desktop\\Projekt\\TimeTestModels\\BTMoveAttribute\\gt\\Project_createTicket.gtEngine");
//		dest = new File("C:\\Users\\Duemmel\\runtime-EclipseApplication2\\Bugtracker\\model\\gt\\Project_createTicket.gtEngine");
//		inputChannel = null;
//		outputChannel = null;
//		try {
//			inputChannel = new FileInputStream(source).getChannel();
//			outputChannel = new FileOutputStream(dest).getChannel();
//			outputChannel.transferFrom(inputChannel, 0, inputChannel.size());
//		} catch (Throwable e) {	e.printStackTrace();} 
//		finally {
//			try {
//				inputChannel.close();
//				outputChannel.close();
//			} catch (IOException e) {e.printStackTrace();}
//		}
//		System.out.println(i);
//		i++;
//		while(i<15){
//			execute2();
//		}
//		return null;
//
//	}
	
	//////////////////////////////////////////////////////////////////
	//	Complete Java Implementation for the sake of testing below	//
	//////////////////////////////////////////////////////////////////

	@SuppressWarnings("rawtypes")
	private void cleanUpAndSave2(EList<EObject> objectsToRemove, Resource res){
		TreeIterator<EObject> iter = res.getAllContents();
		EList<EObject> nacsToRemove = new BasicEList<EObject>();
		while (iter.hasNext()){
			EObject eObject = iter.next();
			if(eObject instanceof  GraphTransformationRule<?, ?>){
				for(Object nac : ((GraphTransformationRule)eObject).getNegativePattern()){
					if(((GTNegativeApplicationCondition)nac).getElements().isEmpty())
						{nacsToRemove.add((EObject) nac);}
				}
			}
		}
		if(objectsToRemove != null && !objectsToRemove.isEmpty()){
			for(EObject o : objectsToRemove){
				EcoreUtil.remove(o);
			}
		}
		if(!nacsToRemove.isEmpty()){
			for(EObject o : nacsToRemove){
				EcoreUtil.remove(o);
			}
		}
		try {
			res.save(java.util.Collections.EMPTY_MAP);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void moveShape2(EObject movedObject, EObject newContainer, String nodeType, GraphTransformationRule rule) {
		TreeIterator<EObject> iter2 = rule.eResource().getAllContents();
		Shape shape = null;
		Node targetNode = null;
		while(iter2.hasNext()){
			EObject next = iter2.next();
			if(next instanceof Shape && ((Shape) next).getElement().equals(movedObject))
				{shape = ((Shape) next);}
			if(next instanceof Node && ((Node) next).getType().equals(nodeType) && ((Node) next).getElement().equals(newContainer))
				{targetNode = ((Node) next);}
		}
		if(shape != null && targetNode != null){
			if(shape.eContainer().eContainer().eContainer().equals(targetNode.eContainer())){	//important when multiple NACs are used in one rule
				for(Object o : targetNode.getPersistedChildren()){
					if(o instanceof BasicCompartment 
						&& ((shape.getElement() instanceof GTAttribute && !((GTAttribute) shape.getElement()).getOperator().getLiteral().equals("="))
						|| (shape.getElement() instanceof GTField && ((GTField) shape.getElement()).getKind().getName().equals("OCL_CONSTRAINT")))
						){
						((BasicCompartment) o).getPersistedChildren().add(shape);
						break;
					}
					else if(o instanceof BasicCompartment
							&& ((shape.getElement() instanceof GTAttribute && ((GTAttribute) shape.getElement()).getOperator().getLiteral().equals("=")) 
							|| (shape.getElement() instanceof GTField && ((GTField) shape.getElement()).getKind().getName().equals("OPERATION_CALL")))
							)
						{((BasicCompartment) o).getPersistedChildren().add(shape);}
				}
			}
		}
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void applyToAffectedObjects2(ENamedElement eNamedElement) {
		for (Resource res : gtResources) {
			TreeIterator<EObject> iter = res.getAllContents();
			EList<EObject> objectsToRemove = new BasicEList<EObject>();
			String ruleName = "";
			while (iter.hasNext()) {
				EObject eObject = iter.next();
				if (eObject instanceof GraphTransformationRule<?, ?>) {
					ruleName = ((GraphTransformationRule) eObject).getName();
					GraphTransformationRule rule = (GraphTransformationRule) eObject;
					EcoreUtil.resolveAll(eObject);
					EList<GTAttribute> gtAttributes = new BasicEList<GTAttribute>();
					EList<GTAttribute> patternAttributes = new BasicEList<GTAttribute>();
					EList<GPElement> patternElements = rule.getPattern().getElements();
					GTNode sourceNodePattern = null;
					GTNode targetNodePattern = null;
					for(GPElement gpe : patternElements){
						if(gpe instanceof GTThisObject && ((EClass) ((GTThisObject)gpe).getType()).getName().equals(sourceClassName))
							sourceNodePattern = (GTNode) gpe;
						else if(gpe instanceof GPUnboundNode && ((EClass) ((GPUnboundNode)gpe).getType()).getName().equals(sourceClassName))
							sourceNodePattern = (GTNode) gpe;
						else if(gpe instanceof GPBoundNode && ((EClass) ((GPBoundNode)gpe).getType()).getName().equals(sourceClassName))
							sourceNodePattern = (GTNode) gpe;
						else if(gpe instanceof GTThisObject && ((EClass) ((GTThisObject)gpe).getType()).getName().equals(targetClassName))
							targetNodePattern = (GTNode) gpe;
						else if(gpe instanceof GPUnboundNode && ((EClass) ((GPUnboundNode)gpe).getType()).getName().equals(targetClassName))
							targetNodePattern = (GTNode) gpe;
						else if(gpe instanceof GPBoundNode && ((EClass) ((GPBoundNode)gpe).getType()).getName().equals(targetClassName))
							targetNodePattern = (GTNode) gpe;
					}
					if(sourceNodePattern != null && targetNodePattern != null){
						EList<GTAttribute<?>> attrs = sourceNodePattern.getAttributes();
						for(int i=attrs.size()-1; i >= 0; i--){
							GTAttribute gta = attrs.get(i);
							if(gta.getExAttribute().eIsProxy()){
								gta.setExAttribute(eNamedElement);
								targetNodePattern.getAttributes().add(gta);
								patternAttributes.add(gta);
							}
						}
					}
					gtAttributes.addAll(patternAttributes);
					EList<GTAttribute> nacAttributes = new BasicEList<GTAttribute>();
					for(Object nac : rule.getNegativePattern()){
						GTNegativeApplicationCondition temp = (GTNegativeApplicationCondition) nac;
						EList<NACElement> nacElements = temp.getElements();
						GTNode sourceNodeNAC = null;
						GTNode targetNodeNAC = null;
						for(NACElement gpe : nacElements){
							if(gpe instanceof GTThisObject && ((EClass) ((GTThisObject)gpe).getType()).getName().equals(sourceClassName))
								sourceNodeNAC = (GTNode) gpe;
							else if(gpe instanceof NACObject && ((EClass) ((NACObject)gpe).getType()).getName().equals(sourceClassName))
								sourceNodeNAC = (GTNode) gpe;
							else if(gpe instanceof NACParameter && ((EClass) ((NACParameter)gpe).getType()).getName().equals(sourceClassName))
								sourceNodeNAC = (GTNode) gpe;
							else if(gpe instanceof NACBoundNode && ((EClass) ((NACBoundNode)gpe).getGPUnboundNode().getType()).getName().equals(sourceClassName))
								sourceNodeNAC = (GTNode) gpe;
							else if(gpe instanceof GTThisObject && ((EClass) ((GTThisObject)gpe).getType()).getName().equals(targetClassName))
								targetNodeNAC = (GTNode) gpe;
							else if(gpe instanceof NACObject && ((EClass) ((NACObject)gpe).getType()).getName().equals(targetClassName))
								targetNodeNAC = (GTNode) gpe;
							else if(gpe instanceof NACParameter && ((EClass) ((NACParameter)gpe).getType()).getName().equals(targetClassName))
								targetNodeNAC = (GTNode) gpe;
							else if(gpe instanceof NACBoundNode && ((EClass) ((NACBoundNode)gpe).getGPUnboundNode().getType()).getName().equals(targetClassName))
								targetNodeNAC = (GTNode) gpe;
						}
						if(sourceNodeNAC != null && targetNodeNAC != null){
							EList<GTAttribute<?>> attrs = sourceNodeNAC.getAttributes();
							for(int i=attrs.size()-1; i >= 0; i--){
								GTAttribute gta = attrs.get(i);
								if(gta.getExAttribute().eIsProxy()){
									gta.setExAttribute(eNamedElement);
									targetNodeNAC.getAttributes().add(gta);
									nacAttributes.add(gta);
								}
							}
						}
					}
					gtAttributes.addAll(nacAttributes);
					TreeIterator<EObject> iter2 = rule.eResource().getAllContents();
					try{
						while (iter2.hasNext()) {
							EObject eObject2 = iter2.next();
							if (!gtAttributes.isEmpty() && eObject2 instanceof Shape) {
								EObject element = ((Shape) eObject2).getElement();
								if (gtAttributes.contains(element)) {
									EObject targetNode = element.eContainer();
									if(patternAttributes != null && targetNode instanceof GTThisObject && targetNode.eContainer() instanceof GTGraphPattern){
										for(GTAttribute gtAttribute : patternAttributes){
											moveShape2(gtAttribute, targetNode, "2001", rule);
										}
									}
									if(patternAttributes != null && targetNode instanceof GPObject){
										for(GTAttribute gtAttribute : patternAttributes){
											String status = ((GPObject) targetNode).getStatus().getName();
											if(status.equals("CREATE"))
												{moveShape2(gtAttribute, targetNode, "2013", rule);}
											else if(status.equals("DELETE"))
												{moveShape2(gtAttribute, targetNode, "2012", rule);}
											else
												{moveShape2(gtAttribute, targetNode, "2011", rule);}
										}
									}
									if(nacAttributes != null && targetNode instanceof GTThisObject && targetNode.eContainer() instanceof GTNegativeApplicationCondition){
										for(GTAttribute gtAttribute : nacAttributes){
											moveShape2(gtAttribute, targetNode, "2018", rule);
										}
									}
									if(nacAttributes != null && targetNode instanceof NACObject){
										for(GTAttribute gtAttribute : nacAttributes){
											moveShape2(gtAttribute, targetNode, "2017", rule);
										}
									}
								}
							} 
							if (patternAttributes != null && patternAttributes.isEmpty() && eObject2 instanceof GTAttribute<?> && ((GTAttribute) eObject2).getExAttribute().eIsProxy()){			
								objectsToRemove.add(eObject2);
							}
							if (patternAttributes != null && patternAttributes.isEmpty() && eObject2 instanceof Shape && objectsToRemove.contains(((Shape) eObject2).getElement())){
								objectsToRemove.add(eObject2);
							}
							if (nacAttributes != null && nacAttributes.isEmpty() && eObject2 instanceof GTAttribute<?> && ((GTAttribute) eObject2).getExAttribute().eIsProxy()){			
								objectsToRemove.add(eObject2);
							}
							if (nacAttributes != null && nacAttributes.isEmpty() && eObject2 instanceof Shape && objectsToRemove.contains(((Shape) eObject2).getElement())){
								objectsToRemove.add(eObject2);
							}
						}						
					}
					catch (Throwable e){}
				} 
				else if (eObject instanceof GTField	&& ((GTField) eObject).getKind().getName().equals("OCL_CONSTRAINT")) {
					String containerName = "OCL_CONSTRAINT";
					String expression = ((GTField) eObject).getContent();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTField) eObject).setContent(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if (eObject instanceof GTPath) {
					String containerName = "GTPath";
					String expression = ((GTPath) eObject).getExpression();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTPath) eObject).setExpression(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if(eObject instanceof GTPrecondition){
					String containerName = "GTPrecondition";
					String expression = ((GTPrecondition) eObject).getCondition();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTPrecondition) eObject).setCondition(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if(eObject instanceof GTPostcondition){
					String containerName = "GTPostcondition";
					String expression = ((GTPostcondition) eObject).getCondition();
					String newExpression = propagation.updateOCLExpressionWithUserInteraction(ruleName, expression, eNamedElement.getName(), containerName);
					if(newExpression != null)
						((GTPostcondition) eObject).setCondition(newExpression);
					if(newExpression != null && newExpression.equals(""))
						objectsToRemove.add(eObject);
				}
				else if(eObject instanceof Shape && objectsToRemove.contains(((Shape)eObject).getElement()))
					objectsToRemove.add(eObject);
			}
			cleanUpAndSave2(objectsToRemove, res);
//			try{
//				boolean result = callValidation(res);
//				if(result == false){
//					JOptionPane.showMessageDialog(null,
//							"Errors exist in the rule " + ruleName + "\nPlease check this rule.", "Validation failed!",
//							JOptionPane.ERROR_MESSAGE);
//				}
//			} catch (Throwable e){
//				e.printStackTrace();
//			}
		}
	}
	
//	@SuppressWarnings("unused")
//	private boolean propagateChanges2(ChangeDescription description,
//			ENamedElement eNamedElement) {
//		EList<FeatureChange> changes = description.getObjectChanges().get(
//				eNamedElement);
//		EList<EObject> addedObjects = description.getObjectsToAttach();
//		EList<EObject> removedObjects = description.getObjectsToDetach();
//		gtResources.clear();
//		getGTResources(eNamedElement.eResource());
//		if (changes != null)
//			for (FeatureChange change : changes) {
//				System.out.println(change + " Name: " + change.getFeatureName()
//						+ " Value: " + change.getDataValue());		
//			}
//		if (addedObjects != null)
//			for (EObject addedObj : addedObjects) {
//				System.out.println(addedObj);				
//			}
//		if (removedObjects != null)
//			for (EObject removedObj : removedObjects) {
//				System.out.println(removedObj);
//			}		
//		applyToAffectedObjects2(eNamedElement);
//		return false;
//	}
	
//	@SuppressWarnings({ "unchecked", "rawtypes" })
//	protected List<EObject> applyToAffectedObjects2(FeatureChange change,
//			ENamedElement eNamedElement) {
//		for (Resource res : gtResources) {
//			TreeIterator<EObject> iter = res.getAllContents();
//			List<EObject> objectsToRemove = new ArrayList<>();
//			while (iter.hasNext()) {
//				EObject eObject = iter.next();
//				if (eNamedElement instanceof EAttribute
//						&& eObject instanceof GTAttribute<?>
//						&& ((GTAttribute) eObject).getExAttribute().eIsProxy()) {
//					GraphTransformationRule<EObject, EObject> rule = (GraphTransformationRule<EObject, EObject>) ((GTAttribute<?>) eObject)
//							.eContainer().eContainer().eContainer();
//					TreeIterator<EObject> ruleContent = rule.eAllContents();
//					Boolean moved = false;
//					while (ruleContent.hasNext()) {
//						EObject ruleObject = ruleContent.next();
//						// target node is a GPObject
//						if (ruleObject instanceof GPObject && !moved) {
//							EClass eClass = (EClass) ((GPObject) ruleObject)
//									.getType();
//							String name = eClass.getName();
//							if (name.equals(targetClassName)) {
//								((GPObject) ruleObject).getAttributes().add(
//										(GTAttribute<?>) eObject);
//								((GTAttribute) eObject)
//										.setExAttribute((EAttribute) eNamedElement);
//								moveShape(res, eObject, ruleObject, "2011");
//								moved = true;
//							}
//						}
//						// target node is a GTThisObject
//						else if (ruleObject instanceof GTThisObject && !moved) {
//							EClass eClass = (EClass) ((GTThisObject) ruleObject)
//									.getType();
//							String name = eClass.getName();
//							if (name.equals(targetClassName)) {
//								((GTThisObject) ruleObject).getAttributes()
//										.add((GTAttribute<?>) eObject);
//								((GTAttribute) eObject)
//										.setExAttribute((EAttribute) eNamedElement);
//								moveShape(res, eObject, ruleObject, "2001");
//								moved = true;
//							}
//						}
//					}
//					if (!moved) {
//						objectsToRemove.add(eObject);
//					}
//				} else if (eObject instanceof Shape
//						&& objectsToRemove.contains(((Shape) eObject)
//								.getElement())) {
//					objectsToRemove.add(eObject);
//				}
//			}
//			if (!objectsToRemove.isEmpty()) {
//				for (EObject o : objectsToRemove) {
//					EcoreUtil.remove(o);
//				}
//			}
//			try {
//				res.save(Collections.EMPTY_MAP);
//			} catch (IOException e) {
//				e.printStackTrace();
//			}
//		}
//		return null;
//	}

}