package de.ubt.ai1.modgraph.example.eRefactoring.connector;

import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JOptionPane;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.change.ChangeDescription;
import org.eclipse.emf.ecore.change.util.ChangeRecorder;
import org.eclipse.emf.ecore.presentation.EcoreEditor;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.handlers.HandlerUtil;

import de.ubt.ai1.modgraph.gt.gtEngine.impl.GTFailureImpl;

public class PullUpEAttributeConnector extends RefactoringConnector {
	private IEditorPart activeEditor;

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {

		activeEditor = HandlerUtil.getActiveEditor(event);
		window = HandlerUtil.getActiveWorkbenchWindow(event);

		if (activeEditor instanceof EcoreEditor) {
			EcoreEditor ecoreEditor = (EcoreEditor) activeEditor;
			ecoreEditor.doSave(null);
			TreeSelection sel = (TreeSelection) ecoreEditor.getSelection();
			Object obj = sel.getFirstElement();

			if (obj instanceof EAttribute) {
				EAttribute attr = (EAttribute) obj;
				EClass clazz = (EClass) attr.eContainer();
				EClass superClass = clazz.getESuperTypes().get(0);
				String superClassName = superClass.getName();

				initRefactoring(clazz.getEPackage().eContents());
//				ChangeRecorder recorder = new ChangeRecorder(superClass);
				try {
					if (!check(superClass, attr.getName())) {
						JOptionPane
								.showMessageDialog(
										null,
										"Not each subclass has an attribute with that name.",
										"ERROR!", JOptionPane.ERROR_MESSAGE);
						return null;
					}
					if (check2(superClass, attr.getName())) {
						JOptionPane
								.showMessageDialog(
										null,
										"Super class already contains an attribute with that name.",
										"ERROR!", JOptionPane.ERROR_MESSAGE);
						return null;
					}
					refactoring
							.pullUpEAttribute(attr.getName(), superClassName);
				} catch (Throwable e) {
					JOptionPane.showMessageDialog(null, "Refactoring failed.",
							"ERROR!", JOptionPane.ERROR_MESSAGE);
					e.printStackTrace();
					return null;
				}
				try {
					clazz.getEPackage().eResource().save(Collections.EMPTY_MAP);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
//				try {
//					ChangeDescription description = recorder.endRecording();
//					if (!(description.eContents().isEmpty())) {
//						propagateChanges(description, superClass);
//					}					
//				} catch (Throwable e){
//					e.printStackTrace();
//				}
			}

		}
		return null;

	}

	public boolean check(EClass superClass, String name) throws GTFailureImpl,
			Throwable {
		EList<EClass> classes = helper.getAllSubClasses(superClass);
		for (EClass c : classes) {
			EList<EAttribute> attrs = c.getEAttributes();
			List<String> temp = new LinkedList<String>();
			for (EAttribute a : attrs)
				temp.add(a.getName());
			int i = 0;
			for (String s : temp)
				if (s.equals(name))
					i++;
			if (i == 0)
				return false;
		}
		return true;
	}

	public boolean check2(EClass superClass, String name){
		for (EAttribute a : superClass.getEAttributes())
			if (a.getName().equals(name))
				return true;
		return false;
	}

	@Override
	protected void applyToAffectedObjects(ENamedElement eNamedElement) {
		for (Resource res : gtResources) {
			
			URI resURI = res.getURI();
			String fragment = resURI.toString();
			String[] resRuleNameArray = fragment.split("/");
			String resRuleName = resRuleNameArray[resRuleNameArray.length-1];			
			int response = JOptionPane.showConfirmDialog(null,
					"Would you like to validate the GT rule " + resRuleName + "?", "Attention",
					JOptionPane.YES_NO_OPTION);
			if(response == 0){
				try{
					boolean result = callValidation(res);
					if(result == false){
						JOptionPane.showMessageDialog(null,
								"Errors exist in the rule " + resRuleName + "\nPlease check it manually.", "Validation failed!",
								JOptionPane.ERROR_MESSAGE);
					}
				} catch (Throwable e){
					e.printStackTrace();
				}
			}
		}
	}
}