/**
 */
package de.ubt.ai1.modGraph.example.eRefactoring.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;
import de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage;
import de.ubt.ai1.modGraph.example.eRefactoring.Helper;
import de.ubt.ai1.modGraph.example.eRefactoring.Propagation;
import de.ubt.ai1.modGraph.example.eRefactoring.Refactoring;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see de.ubt.ai1.modGraph.example.eRefactoring.ERefactoringPackage
 * @generated
 */
public class ERefactoringAdapterFactory extends AdapterFactoryImpl
{
  /**
	 * The cached model package.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  protected static ERefactoringPackage modelPackage;

  /**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  public ERefactoringAdapterFactory()
  {
		if (modelPackage == null) {
			modelPackage = ERefactoringPackage.eINSTANCE;
		}
	}

  /**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
  @Override
  public boolean isFactoryForType(Object object)
  {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

  /**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @generated
	 */
  protected ERefactoringSwitch<Adapter> modelSwitch =
    new ERefactoringSwitch<Adapter>() {
			@Override
			public Adapter caseHelper(Helper object) {
				return createHelperAdapter();
			}
			@Override
			public Adapter caseRefactoring(Refactoring object) {
				return createRefactoringAdapter();
			}
			@Override
			public Adapter casePropagation(Propagation object) {
				return createPropagationAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

  /**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
  @Override
  public Adapter createAdapter(Notifier target)
  {
		return modelSwitch.doSwitch((EObject)target);
	}


  /**
	 * Creates a new adapter for an object of class '{@link de.ubt.ai1.modGraph.example.eRefactoring.Helper <em>Helper</em>}'.
	 * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.Helper
	 * @generated
	 */
  public Adapter createHelperAdapter()
  {
		return null;
	}

  /**
	 * Creates a new adapter for an object of class '{@link de.ubt.ai1.modGraph.example.eRefactoring.Refactoring <em>Refactoring</em>}'.
	 * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.Refactoring
	 * @generated
	 */
  public Adapter createRefactoringAdapter()
  {
		return null;
	}

  /**
	 * Creates a new adapter for an object of class '{@link de.ubt.ai1.modGraph.example.eRefactoring.Propagation <em>Propagation</em>}'.
	 * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.ubt.ai1.modGraph.example.eRefactoring.Propagation
	 * @generated
	 */
  public Adapter createPropagationAdapter()
  {
		return null;
	}

  /**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
  public Adapter createEObjectAdapter()
  {
		return null;
	}

} //ERefactoringAdapterFactory
